#ifndef __BACKGROUND_FX_
#define __BACKGROUND_FX_

#include "GlobalVariable.fx"
//--------------------------------------------------------------//
// Background
//--------------------------------------------------------------//

struct Background_Vertex_Shader_VS_INPUT 
{
    float4 Position : POSITION0;
    float3 Normal : NORMAL0;
};

struct Background_Vertex_Shader_VS_OUTPUT 
{
    float4 Position : POSITION0;
    float3 Texcoord : TEXCOORD0;
};

Background_Vertex_Shader_VS_OUTPUT Background_Vertex_Shader_vs_main( Background_Vertex_Shader_VS_INPUT Input )
{
    Background_Vertex_Shader_VS_OUTPUT Output;
    float4 pos = Input.Position + float4(Input.Normal*900.0f,0); //within the far and near plane
    //pos*=1000.f;
    Output.Position = mul( pos, matViewProjection );
    Output.Texcoord = normalize(Input.Position );
    return( Output );

}

samplerCUBE Background_texcubemap = sampler_state
{
    Texture = (grace_cube_Tex);
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    MINFILTER = LINEAR;
};


float4 Background_Pixel_Shader_ps_main(Background_Vertex_Shader_VS_OUTPUT Input) : COLOR0
{   
    //return(texCUBE(Background_texcubemap,Input.Texcoord ));
    return EnvironmentMap(Input.Texcoord);
}

#endif