//**************************************************************//
//  Effect File exported by RenderMonkey 1.6
//
//  - Although many improvements were made to RenderMonkey FX  
//    file export, there are still situations that may cause   
//    compilation problems once the file is exported, such as  
//    occasional naming conflicts for methods, since FX format 
//    does not support any notions of name spaces. You need to 
//    try to create workspaces in such a way as to minimize    
//    potential naming conflicts on export.                    
//    
//  - Note that to minimize resulting name collisions in the FX 
//    file, RenderMonkey will mangle names for passes, shaders  
//    and function names as necessary to reduce name conflicts. 
//**************************************************************//

//--------------------------------------------------------------//
// Default_DirectX_Effect
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// Pass 0
//--------------------------------------------------------------//
string Default_DirectX_Effect_Pass_0_Model : Mesh = "E:\\developtools\\AMD\\RenderMonkey 1.81\\Examples\\Media\\Models\\Teapot.x";


float4x4 matWorldViewProjection : WorldViewProjection;
float4x4 matWorld : World;
//float4x4 matWorldView : WorldView;
float4   f4lightPos
<
   string UIName = "f4lightPos";
   string UIWidget = "Direction";
   bool UIVisible =  true;
   float4 UIMin = float4( -10.00, -10.00, -10.00, -10.00 );
   float4 UIMax = float4( 10.00, 10.00, 10.00, 10.00 );
   bool Normalize =  false;
> = float4( 100.29, 100.00, 0.80, 1.00 );
float4   vViewPosition : ViewPosition;
float4   f4Fresenel
<
   string UIName = "f4Fresenel";
   string UIWidget = "Direction";
   bool UIVisible =  true;
   float4 UIMin = float4( -10.00, -10.00, -10.00, -10.00 );
   float4 UIMax = float4( 10.00, 10.00, 10.00, 10.00 );
   bool Normalize =  false;
> = float4( 0.95, 0.64, 0.54, 1.00 );
float4   objColor
<
   string UIName = "objColor";
   string UIWidget = "Color";
   bool UIVisible =  true;
> = float4( 0.56, 0.42, 0.28, 1.00 );
float    fK_s_d
<
   string UIName = "fK_s_d";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 1.00;
> = float( 0.3 );

struct VS_INPUT 
{
   float4 Position : POSITION0;
   float4 Normal : NORMAL0;
   
};

struct VS_OUTPUT 
{
   float4 Position : POSITION;
   float3 Normal : TEXCOORD0;
   float3 Light : TEXCOORD1;
   float3 View : TEXCOORD2;
   float3 HALV : TEXCOORD3;
   float4 Diffuse : COLOR0;
   float4 Fresen : COLOR1;
};

VS_OUTPUT Default_DirectX_Effect_Pass_0_Vertex_Shader_vs_main( VS_INPUT Input )
{
   VS_OUTPUT Output;

   float3 diffuse = (float3)objColor;
   float3 view3 = (float3)(vViewPosition - mul(Input.Position,matWorld));
   Input.Normal.w = 0.f;
   float3 normal3 = (float3)(mul(Input.Normal,matWorld));
   float3 light3 = (float3)(f4lightPos);
   
   Output.Normal = normalize(normal3);
   Output.Light = normalize(light3);
   Output.View = normalize(view3);
   Output.HALV = normalize(view3 + light3);
   Output.Diffuse = objColor* fK_s_d;
   Output.Fresen = f4Fresenel;

   Output.Position = mul(Input.Position,matWorldViewProjection);
   return( Output );
   
}




#define PI 3.1415926

float4   ambient
<
   string UIName = "ambient";
   string UIWidget = "Color";
   bool UIVisible =  true;
> = float4( 0.37, 0.28, 0.16, 1.00 );
float    Default_DirectX_Effect_Pass_0_Pixel_Shader_fK_s_d
<
   string UIName = "Default_DirectX_Effect_Pass_0_Pixel_Shader_fK_s_d";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 1.00;
> = float( 0.34 );
float    f1Roughness
<
   string UIName = "f1Roughness";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
   float UIMin = 0.01;
   float UIMax = 1.00;
> = float( 0.47 );
float    f1LightIntensity
<
   string UIName = "f1LightIntensity";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 10.00;
> = float( 0.60 );

struct PS_INPUT 
{
   float4 Position : POSITION;
   float3 Normal : TEXCOORD0;
   float3 Light : TEXCOORD1;
   float3 View : TEXCOORD2;
   float3 HALV : TEXCOORD3;
   float4 Diffuse : COLOR0;
   float4 Fresen : COLOR1;
};


float4 Default_DirectX_Effect_Pass_0_Pixel_Shader_ps_main( PS_INPUT Input) : COLOR0
{

   float3 fresen = (float3)Input.Fresen;
   
   //V.N L.N etc
   float v_dot_n = dot(Input.View, Input.Normal);
   float l_dot_n = dot(Input.Light, Input.Normal);
   float h_dot_n = max(dot(Input.HALV, Input.Normal), 0.f);
   float v_dot_h = max(dot(Input.View, Input.HALV), 0.0f);

   //G   
   float G1 = 2.0f* h_dot_n*v_dot_n/v_dot_h;
   float G2 = 2.0f* h_dot_n*l_dot_n/v_dot_h;

   float G = min(G1,G2);
   G = min(1.0f,G);
   
   //D
   float D = exp(( h_dot_n*h_dot_n - 1)/(h_dot_n*h_dot_n*f1Roughness*f1Roughness))/(f1Roughness*f1Roughness*pow(h_dot_n,4));
   
   //Rd
   float3 R_d = Input.Diffuse;
   
   //Rs
   float3 R_s = (0.f,0.f,0.f);
   if(v_dot_n > 0.0f && l_dot_n > 0.0f) 
   {
   float3 F = fresen + ((1.0f,1.0f,1.0f) - fresen)*(1- pow(v_dot_h,5));
   R_s = F*G*D/PI/v_dot_n/l_dot_n*(1 - Default_DirectX_Effect_Pass_0_Pixel_Shader_fK_s_d);
   }
   float3 finalColor = (R_d + R_s)*l_dot_n*f1LightIntensity + ambient;


   return float4(saturate(finalColor),1.f);
   
}




//--------------------------------------------------------------//
// Technique Section for Default_DirectX_Effect
//--------------------------------------------------------------//
technique Default_DirectX_Effect
{
   pass Pass_0
   {
      VertexShader = compile vs_2_0 Default_DirectX_Effect_Pass_0_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 Default_DirectX_Effect_Pass_0_Pixel_Shader_ps_main();
   }

}

