#ifndef __GLOBALVARIABLE_FX_
#define __GLOBALVARIABLE_FX_

#include "PredefinedGlobal.fx"

//All the texture objects
//Static textures
texture grace_cube_Tex
<
string ResourceName = "tower_cube.dds";//building kitchen campus galileo.dds";cubemap-evul.dds";tower_cube.dds"grace_cube.dds";
>;
texture earth_Tex
<
string ResourceName = "EarthInversed.jpg";//cubemap-evul.dds";grace_cube.dds";
>;

texture vol_Tex
<
string ResourceName = "hallstatt.dds";//wellsvolmap hallstatt
>;

texture cylinder_Tex
<
string ResourceName = "hallstatt_adjust.jpg";//wellsvolmap hallstatt
>;

texture frontBTDF_Tex
<
string ResourceName = "frontBTDF.txt";
>;
texture backBTDF_Tex
<
string ResourceName = "backBTDF.txt";
>;

//Dynamic Texture or rendertarget
texture downsample_MaxTex;
texture downsample_MinTex;
texture back_MaxTex;
texture back_MinTex;
texture backNormal_Tex;
texture backDepth_Tex;
texture back_MergeTex;
texture back_1stMergeTex;
texture back_2ndMergeTex;
texture back_3rdMergeTex;
texture back_4thMergeTex;
texture backRoughness_Tex;

//variable for this application
//TODO: automatically analysis this varible as slider controllable variable
float depthscalar
<
string UIName = "depthscalar";
string UIWidget = "Numeric";
bool UIVisible =  true;
float UIMin = 1.00;
float UIMax = 10000.00;
> = float( 1200.00 );

float roughnessscalar
<
string UIName = "roughnessscalar";
string UIWidget = "Numeric";
bool UIVisible =  true;
float UIMin = 0.00;
float UIMax = 1.00;
> = float( 0.5f );

float roughnessaddition
<
string UIName = "roughnessaddition";
string UIWidget = "Numeric";
bool UIVisible =  true;
float UIMin = 0.00;
float UIMax = 1.00;
> = float( 0.0f );

float N2
<
string UIName = "N2";
string UIWidget = "Numeric";
bool UIVisible =  true;
float UIMin = 0.10;
float UIMax = 3.00;
> = float( 1.300 );

float lodLevel = 0;
bool  preconvolutedEnvMap = true;
const int CONSERVATIVE_STEP_NUMBER = 8;
const float Pi = 3.14159265f;
const float doublePi = 6.2831853f;
const float2 INVALID_PROJECTED_NORMAL = -1; //float2(-1.0f,-1.0f);
//Constant
const float2 offsets[4] = {
    float2(-1, 1), 
    float2( 1, 1),
    float2(-1,-1),
    float2( 1,-1),
};
const float2 frontMaxAlphaKappa = float2(2.0f,4518.0f);
const float2 backMaxAlphaKappa = float2(2.0f,2008.0f);
const float roughnessMax = 500.0f;
const float normalMax = 1.0f; //precision!
const float CUSTOM_MAX_ALPHA = 500.0f;

const float2 DNEG = float2(1.0f,1.0f); //Roughness factor

sampler2D texBackDepth = sampler_state
{
    Texture = ( backDepth_Tex);
    MAGFILTER = LINEAR;
    MINFILTER = LINEAR;
    MIPFILTER = LINEAR;
};
sampler2D texBackNormal = sampler_state
{
    Texture = (backNormal_Tex);
    MAGFILTER = LINEAR;
    MINFILTER = LINEAR;
    MIPFILTER = LINEAR;
};
sampler2D texZmax = sampler_state
{
    Texture = (downsample_MaxTex);
    MAGFILTER = LINEAR;
    MINFILTER = LINEAR;
    MIPFILTER = LINEAR;
};
sampler2D texZmin = sampler_state
{
    Texture = (downsample_MinTex);
    MAGFILTER = LINEAR;
    MINFILTER = LINEAR;
    MIPFILTER = LINEAR;
};
sampler2D texFres;

samplerCUBE Emap = sampler_state
{
    Texture = (grace_cube_Tex);
    MAGFILTER = LINEAR;
    MINFILTER = LINEAR;
    MIPFILTER = LINEAR;
};
sampler3D texvol = sampler_state
{   
    Texture = (vol_Tex);
    MAGFILTER = LINEAR;
    MINFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSW = CLAMP; 
};
sampler2D texearth = sampler_state
{   
    Texture = (earth_Tex);
    MAGFILTER = LINEAR;
    MINFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU = CLAMP;
    ADDRESSV = CLAMP;
};
sampler2D texbackroughness = sampler_state
{   
    Texture = (backRoughness_Tex);
    MAGFILTER = LINEAR;
    MINFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU = CLAMP;
    ADDRESSV = CLAMP;
};
sampler2D texfrontBTDF = sampler_state
{   
    Texture = (frontBTDF_Tex);
    MAGFILTER = LINEAR;
    MINFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU = CLAMP;
    ADDRESSV = CLAMP;
};

sampler2D texbackBTDF = sampler_state
{   
    Texture = (backBTDF_Tex);
    MAGFILTER = LINEAR;
    MINFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU = CLAMP;
    ADDRESSV = CLAMP;
};

sampler2D texcylinder = sampler_state
{   
    Texture = (cylinder_Tex);
    MAGFILTER = LINEAR;
    MINFILTER = LINEAR;
    MIPFILTER = LINEAR;
};

#endif