#ifndef __MINMAXDEPTH_FX_
#define __MINMAXDEPTH_FX_

#include "ShaderHelper.fx"
#include "GlobalVariable.fx"

//--------------------------------------------------------------//
// MinMax
//--------------------------------------------------------------//
struct MinMax_Vertex_Shader_VS_INPUT 
{
    float4 Position : POSITION0;
};

struct MinMax_Vertex_Shader_VS_OUTPUT 
{
    float4 Position : POSITION0;
    float2 texCoord : TEXCOORD0;
};

MinMax_Vertex_Shader_VS_OUTPUT MinMax_Vertex_Shader_vs_main( MinMax_Vertex_Shader_VS_INPUT Input )
{
    MinMax_Vertex_Shader_VS_OUTPUT Output;

    Output.Position = Input.Position;//mul( Input.Position, MinMax_Vertex_Shader_matViewProjection );
    Output.texCoord = float2((Output.Position.x/Output.Position.w + 1)/2 + fInverseViewportWidth/2
        ,(-Output.Position.y/Output.Position.w + 1)/2 + fInverseViewportHeight/2);

    return( Output );

}
sampler2D texback = sampler_state
{   
    Texture = (back_MaxTex);
};
sampler2D texminback = sampler_state
{   
    Texture = (back_MinTex);
};

struct MinMax_Pixel_Shader_VS_OUTPUT 
{
    float4 Position : POSITION0;
    float2 texCoord : TEXCOORD0;
};

struct MinMax_Pixel_Shader_PS_OUTPUT
{
    float4 maxColor : COLOR0;
    float4 minColor : COLOR1;
};
//TODO: clean all the names!
MinMax_Pixel_Shader_PS_OUTPUT MinMax_Pixel_Shader_ps_main(MinMax_Pixel_Shader_VS_OUTPUT input)
{ 
    MinMax_Pixel_Shader_PS_OUTPUT output;
    float maximum = -1e20;
    float minimum = 1e20;
    float tmpDepth = 0.0f;
    float tmpDepth2 = 0.0f;
    float2 f= float2(fInverseViewportWidth,fInverseViewportHeight);

    for( int i = 0; i < 4; i++ )
    {
        tmpDepth = (tex2D( texback, 
            input.texCoord + f*offsets[i] )).r;
        tmpDepth2 = (tex2D( texminback, 
            input.texCoord + f*offsets[i] )).r;
        maximum = max( maximum, tmpDepth );
        if(tmpDepth2 >= 0.00001f)
        {
            minimum = min( minimum, tmpDepth2 );
        }
    }

    output.maxColor = (maximum);
    output.minColor = (minimum);
    return output;

}
#endif